<template src="./template.html"></template>

<script lang="ts">
import { getModule, Watch } from "nuxt-property-decorator";
import { Vue, Component, Prop } from "vue-property-decorator";
import _ from "lodash";
import { apiErrorHandler } from "~/utils/apiHanlers";
//@ts-ignore
import jsonCountry from "@/locales/countryCode.json";
//@ts-ignore
import jsonProvince from "@/locales/provinceCode.json";
// import XLSX from "xlsx";
var momentz = require("moment-timezone");
var moment = require("moment");
//@ts-ignore
import listCountry from "@/locales/listCountry.json";
@Component({
  components: {
    List: () => import("./List/index.vue"),
  },
})
export default class AdminOrderComponent extends Vue {
  tab = 0;
  config = {
    page: 1,
    limit: 25,
    search: "",
    filter: {},
  };
  totalPage: number = 0;
  page = 1;
  menuExport = false;
  listSearchBy = [
    {
      name: "Email & Phone",
      search: "emailPhone",
    },
    {
      name: "Order Id",
      search: "orderCode",
    },
    {
      name: "Transaction Id",
      search: "transactionId",
    },
    {
      name: "Customer Name",
      search: "customerName",
    },
    {
      name: "Tracking Number",
      search: "trackingNumber",
    },
  ];
  listStatus = [
    { name: "Processing", value: "processing" },
    // { name: "Pending", value: 2 },
    { name: "Canceled", value: "canceled" },
    { name: "Fulfilled", value: "fulfilled" },
  ];
  status: any = [];

  listDeliveryStatus = [
    { name: "Paid", value: 1 },
    { name: "Tracking Available", value: 2 },
    { name: "Tracking Online", value: 3 },
    { name: "Delivered & Guarantee", value: 4 },
  ];
  deliveryStatus: any = [];

  dialogExportHistory = false;
  loading = false;
  loadingTable = false;
  loadingExport = false;

  //Drawer Filter
  filter = {
    searchOrder: "",
    searchItem: "",
    processingDate: [],
    createdDate: [],
    sku: "",
    shippingAddress: "",
    billingAddress: "",
    trackingNumber: "",
  };
  drawerFilter = false;
  isFilterOrder = 1;
  progressingDatePicker = false;
  progressingDate = momentz().startOf("month").format("YYYY-MM-DD");
  createdDatePicker = false;
  createdDate = momentz().startOf("month").format("YYYY-MM-DD");

  json_fields = {
    "Order Name": "orderName",
    Sku: "sku",
    "Product Name": "productName",
    "Variant Name": "variantName",
    Quantity: "quantity",
    "Item Status": "itemStatus",
    "Delivery Status": "deliveryStatus",
    "Last Status Updated At": "lastStatusUpdatedAt",
    "Paid At": "paidAt",
    "Processing At": "progressingAt",
    "Fulfilled At": "fulfilledAt",
    "Tracking Number": "trackingNumber",
    "Tracking Status": "trackingStatus",
    "Unit Price": "unitPrice",
    Subtotal: "subTotal",
    "Shipping Price": "shippingPrice",
    "Discount Price": "discountPrice",
    "Total Amount": "totalAmount",
    Refund: "refund",
    "Buyer Name": "buyerName",
    Email: "email",
    "Shipping Address 1": "shippingAddress1",
    "Shipping Address 2": "shippingAddress2",
    "Shipping Phone": "shippingPhone",
    "Shipping City": "shippingCity",
    "Shipping Zip": "shippingZip",
    "Shipping Province": "shippingProvince",
    "Shipping Country": "shippingCountry",
    "Shipping Country Code": "shippingCountryCode",
    "Shipping Province Code": "shippingProvinceCode",
    "Payment Gateway ID": "paymentGateWayId",
    "Gateway Name": "gatewayName",
    "Gateway Type": "gatewayType",
    "Seller Email": "sellerEmail",
    Domain: "domain",
    "Transaction Id": "transactionId",
  };
  json_data: any = [];
  json_meta = [
    [
      {
        key: "charset",
        value: "utf-8",
      },
    ],
  ];

  listOrder = [];
  // listIds = [];
  expand1 = false;
  expand2 = false;
  expand3 = false;
  expand4 = false;
  expand5 = false;
  expand6 = false;
  expand7 = false;
  showSearchBy = false;

  get listIds() {
    return this.$store.state.adminOrder.listIds;
  }

  set listIds(value: string[]) {
    this.$store.commit("adminOrder/setListIds", value);
  }

  get from() {
    return this.$store.state.setting.from;
  }

  get to() {
    return this.$store.state.setting.to;
  }

  get timezone() {
    return this.$store.state.setting.timezone;
  }

  get searchBy() {
    return this.$store.state.adminOrder.searchBy;
  }

  set searchBy(value: string) {
    this.$store.commit("adminOrder/setSearchBy", value);
  }

  openDialogExportHistory() {
    this.dialogExportHistory = true;
  }

  mounted() {}

  fetchData() {
    this.json_data = [];
    if (this.listIds.length) {
      const listAllOrder = this.$store.state.adminOrder.listAllOrder;
      for (let id of this.listIds) {
        const findOrder: any = listAllOrder.find(
          (order: any) => order._id === id
        );
        if (findOrder) {
          this.onParseListExport(findOrder);
        }
      }
    } else {
      const listAllExportOrder =
        this.$store.state.adminOrder.listAllExportOrder;
      for (let order of listAllExportOrder) {
        if (order) {
          this.onParseListExport(order);
        }
      }
    }
  }

  onParseListExport(findOrder?: any) {
    let listVariant;
    let listProduct;
    let listQuantity;
    let listSku;
    let listSlug;
    let shippingPrice;
    let listSubtotal;
    if (findOrder?.listSelectedProductId?.length) {
      listVariant = findOrder.listSelectedProductId
        .map((product: any) => product?.listValue)
        .join("\n");
      listProduct = findOrder.listSelectedProductId
        .map((product: any) => product?.productName)
        .join("\n");
      listQuantity = findOrder.listSelectedProductId
        .map((product: any) => product?.quantity)
        .join("\n");
      listSku = findOrder.listSelectedProductId
        .map((product: any) => {
          return product?.sku;
        })
        .join("\n");
      listSlug = findOrder.listSelectedProductId
        .map((product: any) => product?.slug)
        .join("\n");
    }
    if (findOrder && findOrder.shippingAddress) {
      let payment = "";
      if (findOrder?.paypal?.paymentID) {
        payment = "Paypal";
      } else if (findOrder?.stripe) {
        payment = "Stripe";
      }
      let itemStatus = "";
      if (findOrder.orderStatus === "processing") itemStatus = "Processing";
      else if (findOrder.orderStatus === "pending") itemStatus = "Pending";
      else if (findOrder.orderStatus === "canceled") itemStatus = "Canceled";
      else if (findOrder.orderStatus === "fulfilled") itemStatus = "Fulfilled";

      let deliveryStatus = "";
      if (findOrder.shippingStatus === 1) deliveryStatus = "TRACKING_PAID";
      else if (findOrder.shippingStatus === 2)
        deliveryStatus = "TRACKING_AVAILABLE";
      else if (findOrder.shippingStatus === 3)
        deliveryStatus = "TRACKING_ONLINE";
      else if (findOrder.shippingStatus === 4)
        deliveryStatus = "TRACKING_DELIVERY&GUARANTEE";

      const {
        address,
        apartment,
        city,
        companyName,
        country,
        email,
        firstName,
        lastName,
        phoneNumber,
        state,
        zipCode,
      } = findOrder.shippingAddress;
      const { listSelectedProductId } = findOrder;
      const findCountry = listCountry.find(
        (qg: any) => qg.code === country || qg.name === country
      );
      if (listSelectedProductId.length === 1) {
        //@ts-ignore
        this.json_data.push({
          orderName: findOrder.orderCode,
          sku: listSku,
          productName: listProduct || "",
          variantName: listVariant || "",
          quantity: listQuantity || "",
          itemStatus,
          deliveryStatus,
          lastStatusUpdatedAt:
            findOrder.updatedAt && this.formatDate(findOrder.updatedAt),
          paidAt: findOrder.createdAt && this.formatDate(findOrder.createdAt),
          progressingAt:
            findOrder.processingDate &&
            this.formatDate(findOrder.processingDate),
          fulfilledAt: findOrder.fulfilledAt || "",
          trackingNumber: findOrder.trackingNumber,
          trackingStatus: "",
          unitPrice: findOrder?.listSelectedProductId[0]?.price || 0,
          subTotal: findOrder.subTotal,
          shippingPrice: findOrder.shipping,
          discountPrice: findOrder.discount,
          totalAmount: findOrder.total - (findOrder.tip || 0),
          refund: 0,
          buyerName: `${findOrder.shippingAddress.firstName} ${findOrder.shippingAddress.lastName}`,
          email: findOrder.shippingAddress.email,
          shippingAddress1: address,
          shippingAddress2: apartment,
          shippingPhone: phoneNumber,
          shippingCity: city,
          shippingZip: zipCode,
          shippingProvince: this.findProvinceCode(state),
          shippingCountry: findCountry?.name || country,
          shippingCountryCode:
            findCountry?.code || this.findCountryCodeByCountry(country),
          shippingProvinceCode: state || "",
          paymentGateWayId: "",
          gatewayName: findOrder?.paymentId?.name || "",
          gatewayType: payment,
          sellerEmail: findOrder?.sellerId?.email || "",
          domain: findOrder?.storeId?.domain || "",
          transactionId:
            findOrder?.paypal?.paymentID || findOrder?.stripe?.id || "",
        });
      } else {
        console.log("price :>> ", findOrder.price);
        for (let i = 0; i < listSelectedProductId.length; i++) {
          const subTotal = _.sumBy(listSelectedProductId, "price");
          const product = listSelectedProductId[i];
          //@ts-ignore
          this.json_data.push({
            orderName: findOrder.orderCode,
            sku: product.sku || "",
            productName: product.productName || "",
            variantName: product.listValue.join(",") || "",
            quantity: product.quantity,
            itemStatus,
            deliveryStatus,
            lastStatusUpdatedAt:
              findOrder.updatedAt && this.formatDate(findOrder.updatedAt),
            paidAt: findOrder.createdAt && this.formatDate(findOrder.createdAt),
            progressingAt:
              findOrder.processingDate &&
              this.formatDate(findOrder.processingDate),
            fulfilledAt: findOrder.fulfilledAt || "",
            trackingNumber: findOrder.trackingNumber,
            trackingStatus: "",
            unitPrice: product?.price || 0,
            subTotal: i === 0 ? subTotal : 0,
            shippingPrice: i === 0 ? findOrder.shipping : 0,
            discountPrice: i === 0 ? findOrder.discount : 0,
            totalAmount: i === 0 ? findOrder.total : 0,
            refund: 0,
            buyerName: `${findOrder.shippingAddress.firstName} ${findOrder.shippingAddress.lastName}`,
            email: findOrder.shippingAddress.email,
            shippingAddress1: address,
            shippingAddress2: apartment,
            shippingPhone: phoneNumber,
            shippingCity: city,
            shippingZip: zipCode,
            shippingProvince: this.findProvinceCode(state),
            shippingCountry: findCountry?.name || country,
            shippingCountryCode:
              findCountry?.code || this.findCountryCodeByCountry(country),
            shippingProvinceCode: state || "",
            paymentGateWayId: "",
            gatewayName: findOrder?.paymentId?.name || "",
            gatewayType: payment,
            sellerEmail: findOrder?.sellerId?.email || "",
            domain: findOrder?.storeId?.domain || "",
            transactionId:
              findOrder?.paypal?.paymentID || findOrder?.stripe?.id || "",
          });
        }
      }
    }
  }

  onRedirectPage() {
    this.config.page = this.page;
  }

  removeFilter(item: string) {
    const findStatus = this.status.findIndex((elem: any) => elem === item);
    if (findStatus !== -1) {
      this.$store.commit("adminOrder/setFilterStatus", {
        value: findStatus,
        type: "orderStatus",
      });
    }
    const findDeliveryStatus = this.deliveryStatus.findIndex(
      (elem: any) => elem === item
    );
    if (findDeliveryStatus !== -1) {
      this.$store.commit("adminOrder/setFilterStatus", {
        value: findDeliveryStatus,
        type: "shippingStatus",
      });
    }
  }

  onClearFilter(value: number) {
    if (value === 1) {
      this.filter.searchOrder = "";
    } else if (value === 2) {
      this.filter.searchItem = "";
    } else if (value === 3) {
      this.filter.processingDate = [];
    } else if (value === 4) {
      this.filter.createdDate = [];
    } else if (value === 5) {
      this.filter.shippingAddress = "";
    } else if (value === 6) {
      this.filter.billingAddress = "";
    } else if (value === 7) {
      this.filter.trackingNumber = "";
    }
  }

  onClearAllFilter() {
    this.filter = {
      searchOrder: "",
      searchItem: "",
      processingDate: [],
      createdDate: [],
      sku: "",
      shippingAddress: "",
      billingAddress: "",
      trackingNumber: "",
    };
    this.drawerFilter = false;
    this.$store.commit("adminOrder/setListFilterOther", {});
    this.$store.dispatch("adminOrder/onGetListOrder", { ctx: this });
    this.listIds = [];
    this.expand1 = false;
    this.expand2 = false;
    this.expand3 = false;
    this.expand4 = false;
    this.expand5 = false;
    this.expand6 = false;
    this.expand7 = false;
  }

  onSearch() {
    this.$store.commit("adminOrder/setSearch", this.config.search);
    this.$store.dispatch("adminOrder/onGetListOrder", {
      ctx: this,
      resetPage: true,
    });
    this.listIds = [];
  }

  onHandleSearch() {
    this.config.page = 1;
    this.$store.commit("adminOrder/setPage", this.config.page);
    this.onSearch();
  }

  beforeDestroy() {
    this.$store.commit("adminOrder/setSetConfig");
  }

  async onHandleFilter() {
    try {
      let filter: any = {};

      for (let elem of Object.keys(this.filter)) {
        //@ts-ignore
        if (!this.filter[elem]) {
          continue;
        }
        if (elem !== "processingDate" && elem !== "createdDate") {
          // @ts-ignore
          filter[elem] = this.filter[elem];
        } else {
          if (
            //@ts-ignore
            this.filter[elem].length > 0 &&
            elem === "processingDate"
          ) {
            this.$store.commit("setting/setTime", {
              dateStart: this.filter["processingDate"][0],
              dateEnd: this.filter["processingDate"][1],
            });
            filter[elem] = {
              from: this.from,
              to: this.to,
            };
          } else if (
            //@ts-ignore
            this.filter[elem].length > 0 &&
            elem === "createdDate"
          ) {
            this.$store.commit("setting/setTime", {
              dateStart: this.filter["createdDate"][0],
              dateEnd: this.filter["createdDate"][1],
            });
            filter[elem] = {
              from: this.from,
              to: this.to,
            };
          }
        }
      }
      this.loading = true;
      this.$store.commit("adminOrder/setListFilterOther", filter);
      await this.$store.dispatch("adminOrder/onGetListOrder", {
        ctx: this,
      });
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onExportFile() {
    if (!this.listIds.length) {
      this.loadingExport = true;
      await this.$store.dispatch("adminOrder/onGetAllList", { ctx: this });
    }
    //@ts-ignore
    this.$refs.export.$el.click();
    this.loadingExport = false;
  }

  async onChangeStatus(status: string) {
    try {
      this.loading = true;
      const payload = {
        listOrderId: this.listIds,
        orderStatus: status,
      };
      await this.$api.order.updateOrder(payload);
      this.$pushNotification.success("Status change successful");
      this.$store.dispatch("adminOrder/onGetListOrder", { ctx: this });
      this.listIds = [];
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  get statusViewer() {
    return this.$store.state.adminOrder.listFilter.orderStatus;
  }

  get deliveryStatusViewer() {
    return this.$store.state.adminOrder.listFilter.shippingStatus;
  }

  get total() {
    return this.$store.state.adminOrder.total;
  }

  // openExpandFilter(num: number) {
  //   if (this.isFilterOrder != num) {
  //     this.isFilterOrder = num;
  //   } else {
  //     this.isFilterOrder = 0;
  //   }
  // }

  findNameStatus(value: number) {
    const findName: any = this.listStatus.find(
      (item: any) => item.value === value
    );
    return findName?.name || "";
  }

  findNameDeliveryStatus(value: number) {
    const findName: any = this.listDeliveryStatus.find(
      (item: any) => item.value === value
    );
    return findName?.name || "";
  }

  get dateRangeProcessingText() {
    return this.filter.processingDate.join(" - ");
  }

  get dateRangeCreatedText() {
    return this.filter.createdDate.join(" - ");
  }

  formatDate(date: string) {
    return moment(date).format("HH:mm DD/MM/YYYY");
  }

  findCountryCodeByCountry(country: string) {
    for (let item in jsonCountry) {
      if (jsonCountry[item] === country) {
        return item;
      }
    }
  }

  findProvinceCode(province: string) {
    const findProvince = jsonProvince.find(
      (item: any) => item.abbreviation === province
    );
    if (findProvince) {
      return findProvince.name;
    }
    return province;
  }

  @Watch("status")
  changedStatus(list: string[]) {
    this.$store.commit("adminOrder/setListFilter", {
      filter: list,
      status: "orderStatus",
    });
    this.$store.dispatch("adminOrder/onGetListOrder", { ctx: this });
    this.listIds = [];
  }

  @Watch("searchBy")
  changeSearchBy(value: string) {
    if (this.config.search) {
      this.$store.dispatch("adminOrder/onGetListOrder", {
        ctx: this,
      });
    }
  }

  @Watch("deliveryStatus")
  changedDeliveryStatus(list: string[]) {
    console.log("vào day");
    this.$store.commit("adminOrder/setListFilter", {
      filter: list,
      status: "shippingStatus",
    });
    this.$store.dispatch("adminOrder/onGetListOrder", { ctx: this });
    this.listIds = [];
  }

  @Watch("tab")
  async changedTab(value: number) {
    this.$store.commit("adminOrder/setPage", 1);
    this.$store.commit("adminOrder/setPageRedirect", 1);
    this.$store.commit("adminOrder/setSearch", "");
    if (value === 0) {
      this.status = [];
      this.deliveryStatus = [];
    }
    if (value === 1) {
      this.status = ["processing"];
      this.deliveryStatus = [];
    }
    // if (value === 2) {
    // 	this.status = [2];
    // 	this.deliveryStatus = [];
    // }
    if (value === 2) {
      this.status = ["canceled"];
      this.deliveryStatus = [];
    }
    if (value === 3) {
      this.status = ["fulfilled"];
      this.deliveryStatus = [];
    }
    if (value === 4) {
      this.deliveryStatus = [1];
      this.status = [];
    }
    if (value === 5) {
      this.deliveryStatus = [2];
      this.status = [];
    }
    if (value === 6) {
      this.deliveryStatus = [3];
      this.status = [];
    }
    if (value === 7) {
      this.deliveryStatus = [4];
      this.status = [];
    }
    // this.$store.dispatch("adminOrder/onGetListOrder", {
    // 	ctx: this,
    // });
    this.$store.commit("adminOrder/setLimit", 25);
  }

  @Watch("drawerFilter")
  changedDrawerFilter(value: boolean) {
    if (value) {
      this.$store.commit("adminOrder/setSetConfig");
    }
  }
}
</script>

<style lang="scss" scoped>
.v-menu__content {
  box-shadow: rgba(100, 100, 111, 0.2) 0px 7px 29px 0px !important;
  top: 230px !important;
}
</style>

<style scoped lang="scss">
.btns {
  @media (max-width: 640px) {
    margin-bottom: 8px;
  }
}

.status-btn {
  width: 150px;

  @media (max-width: 360px) {
    width: 100% !important;
  }
}

.delivery-status-btn {
  width: 170px;

  @media (max-width: 360px) {
    width: 100% !important;
  }
}

.list-menu {
  width: 100%;
}

.list-menu:hover {
  background-color: #ecf0f1;
}

.list-menu--active {
  background-color: #076ce3;
  padding: 4px 8px;
}

.v-list-item__action {
  margin-right: 12px !important;
}

.change-status:hover {
  background-color: #ecf0f1 !important;
}
</style>
